import Downloader, { DownloadTask, LiveDownloaderConfig } from "./downloader";
import { Playlist } from "./m3u8";
/**
 * Live Downloader
 */
export default class LiveDownloader extends Downloader {
    finishedInitialChunkUrls: string[];
    finishedSequenceIds: number[];
    m3u8: Playlist;
    downloadTasks: DownloadTask[];
    allDownloadTasks: DownloadTask[];
    runningThreads: number;
    totalCount: number;
    isEnd: boolean;
    isDownloadFinished: boolean;
    isStarted: boolean;
    forceStop: boolean;
    prefix: string;
    retries: number;
    /**
     *
     * @param m3u8Path
     * @param config
     * @param config.threads 线程数量
     */
    constructor(m3u8Path: string, { threads, output, tempDir, key, verbose, retries, proxy, cookies, headers, keep, noMerge, keepEncryptedChunks, chunkNamingStrategy, cliMode, }: LiveDownloaderConfig);
    refreshM3U8(): Promise<void>;
    download(): Promise<void>;
    cycling(): Promise<void>;
    /**
     * Stop downloading for external use
     */
    stopDownload(): void;
    checkQueue(): void;
    saveTask(): void;
}
