"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFileExt = exports.getAvailableOutputPath = exports.buildFullUrl = void 0;
const url_1 = require("url");
const fs = __importStar(require("fs"));
function buildFullUrl(host, path) {
    if (path.startsWith("http")) {
        return path;
    }
    return new url_1.URL(path, host).href;
}
exports.buildFullUrl = buildFullUrl;
function getAvailableOutputPath(path) {
    const pathArr = path.split(".");
    const filePath = pathArr.slice(0, -1).join(".");
    const ext = pathArr[pathArr.length - 1];
    if (fs.existsSync(path) || fs.existsSync(`${filePath}_0.${ext}`)) {
        // output filename conflict
        return `${filePath}_${Date.now()}.${ext}`;
    }
    return path;
}
exports.getAvailableOutputPath = getAvailableOutputPath;
/** 获得文件后缀名 */
function getFileExt(filePath) {
    let ext = "";
    if (filePath.startsWith("http://") || filePath.startsWith("https://")) {
        const urlPath = new url_1.URL(filePath).pathname.slice(1).split("/");
        if (urlPath[urlPath.length - 1].includes(".")) {
            ext = urlPath[urlPath.length - 1].split(".").slice(-1)[0];
        }
    }
    else {
        const filePathArr = filePath.split("/");
        const filename = filePathArr[filePathArr.length - 1];
        ext = filename.includes(".") ? filename.split(".").slice(-1)[0] : "";
    }
    return ext;
}
exports.getFileExt = getFileExt;
//# sourceMappingURL=common.js.map