"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = __importDefault(require("chalk"));
class ConsoleLogger {
    constructor() {
        this.isDebugMode = false;
    }
    debug(message) {
        this.isDebugMode && console.debug(chalk_1.default.gray(`[MINYAMI][DEBUG] ${message}`));
    }
    info(message) {
        console.info(chalk_1.default.white(`[MINYAMI][INFO] ${message}`));
    }
    warning(message) {
        console.warn(chalk_1.default.yellow(`[MINYAMI][WARN] ${message}`));
    }
    error(message, error) {
        if (error !== undefined) {
            this.isDebugMode && console.debug(error);
        }
        console.info(chalk_1.default.red(`[MINYAMI][ERROR] ${message}`));
    }
    enableDebugMode() {
        this.isDebugMode = true;
    }
}
exports.default = new ConsoleLogger();
//# sourceMappingURL=log.js.map