"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteTask = exports.saveTask = exports.getTask = void 0;
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
/**
 * Get previous task
 * @param taskId
 */
function getTask(taskId) {
    const taskFilePath = path.resolve(__dirname, "../../tasks.json");
    if (!fs.existsSync(taskFilePath)) {
        return;
    }
    const taskFileContent = fs.readFileSync(taskFilePath).toString();
    try {
        const previousTasks = JSON.parse(taskFileContent);
        const index = previousTasks.findIndex((t) => {
            return t.id === taskId;
        });
        if (index === -1) {
            return;
        }
        return previousTasks[index];
    }
    catch (e) {
        return;
    }
}
exports.getTask = getTask;
/**
 * Save(add) or update task
 * @param task
 */
function saveTask(task) {
    const taskFilePath = path.resolve(__dirname, "../../tasks.json");
    const tasks = [];
    if (fs.existsSync(taskFilePath)) {
        const taskFileContent = fs.readFileSync(taskFilePath).toString();
        try {
            const previousTasks = JSON.parse(taskFileContent);
            tasks.push(...previousTasks);
        }
        catch (e) {
            throw new Error("Fail to parse previous tasks, ignored. " + e);
        }
    }
    const index = tasks.findIndex((t) => t.id === task.id);
    if (index !== -1) {
        // Update previous task
        tasks[index] = task;
    }
    else {
        tasks.push(task);
    }
    // Write back to file
    fs.writeFileSync(taskFilePath, JSON.stringify(tasks, null, 2));
}
exports.saveTask = saveTask;
/**
 * Delete task
 * @param taskId
 */
function deleteTask(taskId) {
    const taskFilePath = path.resolve(__dirname, "../../tasks.json");
    const tasks = [];
    if (!fs.existsSync(taskFilePath)) {
        // No previous tasks. No task to delete.
        return false;
    }
    const taskFileContent = fs.readFileSync(taskFilePath).toString();
    try {
        const previousTasks = JSON.parse(taskFileContent);
        tasks.push(...previousTasks);
    }
    catch (e) {
        throw new Error("Fail to parse previous tasks, ignored. " + e);
    }
    const index = tasks.findIndex((t) => t.id === taskId);
    if (index === -1) {
        return false;
    }
    else {
        // Write back to file
        fs.writeFileSync(taskFilePath, JSON.stringify(tasks.filter((t) => t.id !== taskId), null, 2));
    }
}
exports.deleteTask = deleteTask;
//# sourceMappingURL=task.js.map